bool enableMenu = false;
bool enableSelectorMenu = false;
bool enableRead = true;
bool reloadMap = false;
GhostId@ discoveredGhost = CreateGhostId(-1, "None", "None", "None", "None", -1);
GhostId@ personalBestGhost = CreateGhostId(-1, "None", "None", "None", "None", -1);
GhostId[] changedGhosts;
int currentID = 0;
int ghostArraySize = -1;
int selectedIndex = -1;
int overwriteIndex = -1;
int cacheLength = -1;
string selectedCombo = "";
string loadedTitle = "";
bool isSorted = false;
UI::TableColumnSortSpecs[] tableSpecs;

void Render() 
{
    UpdatedLoadedTitle();
    RenderUI();
    GhostSelectorUI();

    if (GetApp().PlaygroundScript is null) {
        discoveredGhost = CreateGhostId(-1, "None", "None", "None", "None", -1);
        personalBestGhost = CreateGhostId(-1, "None", "None", "None", "None", -1);
        return;
    }

    if (GetApp().PlaygroundScript.ServerModeName != 'CampaignSolo' && GetApp().PlaygroundScript.ServerModeName != 'TMC_CampaignSolo') return;
    auto dataFileMgr = GetDataMgr();
    auto rootMap = GetMap();
    personalBestGhost = FindMapPB();

    if (dataFileMgr.Ghosts.Length != 0 && personalBestGhost.raceTime != -1 && Setting_Scan) {
        int lastIndexGhost = dataFileMgr.Ghosts.Length - 1;
#if MP4
        bool condition = int(dataFileMgr.Ghosts.Length) != ghostArraySize;
#elif TURBO
        bool condition = discoveredGhost.Nickname != GetGhostName(lastIndexGhost);
#endif
        if (condition) {
            ghostArraySize = dataFileMgr.Ghosts.Length;
            if (!IsGhostMedal(lastIndexGhost) && !IsGhostPB(lastIndexGhost) && CompareDiscoveredTime(lastIndexGhost)) {
#if TURBO
                discoveredGhost = CreateGhostId(IncrementId(), loadedTitle, rootMap.MapName, 'None', GetGhostName(lastIndexGhost), GetGhostTime(lastIndexGhost), false);
#endif
                string fileName = LatestFile();
                if (fileName != '' && fileName != 'oldMatch') {
                    discoveredGhost = CreateGhostId(IncrementId(true), loadedTitle, rootMap.MapName, fileName, GetGhostName(lastIndexGhost), GetGhostTime(lastIndexGhost), false);
                    changedGhosts.InsertAt(0, discoveredGhost);
                }
            }
        }
    }
}


int IncrementId(bool increment = false) {if (increment) currentID++; return currentID;}


void CreateNonExistentFolder() 
{
    if (!IO::FolderExists(IO::FromDataFolder("STMGhostInject\\OriginalReplays"))) IO::CreateFolder(IO::FromDataFolder("STMGhostInject\\OriginalReplays"));
#if TURBO
    if (!IO::FolderExists(Setting_OverwriteLocation)) IO::CreateFolder(Setting_OverwriteLocation);
#endif
}


void UpdatedLoadedTitle() {
#if MP4
    if (GetManiaPlanetAPI().LoadedTitle is null) return;
    loadedTitle = GetManiaPlanetAPI().LoadedTitle.TitleId.Split('@')[0];
#elif TURBO
    if (GetApp().Challenge is null) return;
    loadedTitle = GetApp().Challenge.CollectionName;
#endif
}


void OverwriteGhost(int index, const string &in fileName) 
{
#if MP4
    CopyFile(Setting_OverwriteLocation + '\\' + fileName, "C:\\ProgramData\\" + GetGameType() + "\\Cache\\" + changedGhosts[index].fileName, true);
#elif TURBO
    if (fileName != 'STM' && fileName != 'RTM') CopyFile(Setting_OverwriteLocation + '\\' + fileName, "C:\\ProgramData\\" + GetGameType() + "\\Cache\\" + changedGhosts[index].fileName, true);
    else CopyFile("Ghosts\\" + GhostType(fileName) + GetSTMGhostFileName(changedGhosts[index].mapName), "C:\\ProgramData\\TrackmaniaTurbo\\Cache\\" + changedGhosts[index].fileName);
#endif
}

#if MP4
GhostId@ FindMapPB() 
{
    auto scoreMgr = GetApp().PlaygroundScript.ScoreMgr;
    if (GetApp().RootMap is null) return CreateGhostId(-1, "None", "None", "None", "None", -1);
    for (uint i = 0; i < scoreMgr.TaskResults.Length; i++) {
        CWebServicesTaskResult_GhostScript@ ghost = cast<CWebServicesTaskResult_GhostScript@>(scoreMgr.TaskResults[i]);
        if (ghost is null) continue;
        if (ghost.HasSucceeded) return CreateGhostId(IncrementId(), loadedTitle, formatCleanerManiaplanet(GetApp().RootMap.MapName), "None", ghost.Ghost.Nickname, ghost.Ghost.Result.Time);
    }
    return CreateGhostId(-1, "None", "None", "None", "None", -1);
}
#endif

bool CompareDiscoveredTime(int index) 
{
    if (discoveredGhost.Nickname != GetGhostName(index) && discoveredGhost.raceTime != GetGhostTime(index)) return true;
    else return false;
}

bool IsGhostMedal(int index) 
{
    auto dataFileMgr = GetDataMgr();
    return dataFileMgr.Ghosts[index].Nickname == "Author Medal" ||
           dataFileMgr.Ghosts[index].Nickname == "Gold Medal" ||
           dataFileMgr.Ghosts[index].Nickname == "Silver Medal" ||
           dataFileMgr.Ghosts[index].Nickname == "Bronze Medal";
}

bool IsGhostPB(int index) 
{
    auto ghost = GetDataMgr().Ghosts[index];
#if MP4
    if (ghost.Nickname == personalBestGhost.Nickname && ghost.Result.Time == personalBestGhost.raceTime) return true;
#elif TURBO
    if (ghost.Nickname == personalBestGhost.Nickname && ghost.RaceResult.Time == personalBestGhost.raceTime) return true;
#endif
    else return false;
}

#if TURBO
GhostId@ FindMapPB() 
{
    auto dataFileMgr = GetDataMgr();
    auto rootMap = GetMap();
    if (rootMap is null || dataFileMgr is null) return CreateGhostId(-1, "None", "None", "None", "None", -1);
    for (uint i = 0; i < dataFileMgr.Ghosts.Length; i++) {
        if (dataFileMgr.Ghosts[i].RaceResult is null || IsGhostMedal(i)) continue;
        if (int(dataFileMgr.Ghosts[i].RaceResult.Time) != -1) return CreateGhostId(IncrementId(), loadedTitle, formatCleanerManiaplanet(rootMap.MapName), "None", dataFileMgr.Ghosts[i].Nickname, dataFileMgr.Ghosts[i].RaceResult.Time);
    }
    return CreateGhostId(-1, "None", "None", "None", "None", -1);
}

bool CompareRecordsTime(int lastIndexGhost) 
{
    auto dataFileMgr = GetApp().PlaygroundScript.DataMgr;

    if (dataFileMgr.Ghosts[lastIndexGhost] is null) return false;
    if (dataFileMgr.Ghosts[lastIndexGhost].RaceResult is null) return false;
    
    for (uint i = 0; i < dataFileMgr.Records.Length; i++) {
        if (dataFileMgr.Records[i] is null) continue;
        if (uint(dataFileMgr.Ghosts[lastIndexGhost].RaceResult.Time) == dataFileMgr.Records[i].Time) return false;
    }
    return true;
}

string GhostType(const string& in type) 
{
    return type == 'RTM' ? 'RTM\\' : 'STM\\';
}

string GetSTMGhostFileName(const string &in mapName) 
{
    int mapNameInt = Text::ParseInt(mapName);
    if (mapNameInt > 0 && mapNameInt <= 200) {
        return mapName + '.Ghost.Gbx';
    } else return 'epicFail.txt';
}
#endif

string GetGameType() {
#if MP4
    return 'ManiaPlanet';
#elif TURBO
    return 'TrackmaniaTurbo';
#endif
}

bool GhostFileFind(const string &in filename)
{
    for (uint i = 0; i < changedGhosts.Length; i++) {if (filename.Contains(changedGhosts[i].fileName)) return true;}
    return false;
}

string LatestFile() 
{
    string[] cacheList = IO::IndexFolder("C:\\ProgramData\\" + GetGameType() + "\\Cache", false);
    if (int(cacheList.Length) == cacheLength) {return '';}
    cacheLength = cacheList.Length;
    int latestIndex = -1;
    int latestTime = -1;

    for (uint i = 0; i < cacheList.Length; i++) {
        string[] fileName = cacheList[i].Split('/');
        int modifiedTime = IO::FileModifiedTime(cacheList[i]);
        if (modifiedTime > latestTime && !GhostFileFind(fileName[fileName.Length - 1])) {
            latestTime = modifiedTime;
            latestIndex = i;
        }
    }

    if (latestIndex == -1) return '';

    string[] ret = cacheList[latestIndex].Split('/');
    if (latestTime + 1 > Time::get_Stamp() && latestTime - 1 < Time::get_Stamp()) {
        return ret[ret.Length - 1];
    } else {
        for (uint i = 0; i < changedGhosts.Length; i++) if (changedGhosts[i].fileName == ret[ret.Length - 1]) return 'oldMatch';
        return '';
    }
}

void Main()
{
#if TMNEXT
    warn('This plugin does not support TM2020.');
    return;
#elif MP4
    LoadCachedReplays();
#endif

    CreateNonExistentFolder();
    while (true) {
        if (reloadMap) {
            ReloadMap();
            reloadMap = false;
        }
        yield();
    }
}

void LoadCachedReplays() {
    auto doc = XML::Document(IO::File(IO::FromUserGameFolder("Config\\checksum.txt"), IO::FileMode::Read).ReadToEnd());
    auto node = doc.Root().FirstChild().Child('packdesc');

    while(node.NextSibling().Child('name').Content() != '') {
        node = node.NextSibling();
        if (!node.Child('name').Content().Contains('.replay.gbx')) continue;
        string[] pathSplit = node.Child('name').Content().Split('\\');
        string[] replayParts = pathSplit[pathSplit.Length - 1].Split('_', 2);
        string[] nameTimeSplit = replayParts[1].Split('_(');

        bool isHooked = IO::FileExists(IO::FromDataFolder("STMGhostInject\\OriginalReplays\\" + node.Child('file').Content().Split('\\')[1]));
        changedGhosts.InsertLast(CreateGhostId(IncrementId(true), pathSplit[pathSplit.Length - 2].Split('@')[0], replayParts[0], node.Child('file').Content().Split('\\')[1], nameTimeSplit[0], ParseStringTime(nameTimeSplit[1]), isHooked));
    }
}

CGameCtnChallenge@ GetMap() {
#if MP4
    return GetApp().RootMap;
#elif TURBO
    return GetApp().Challenge;
#endif
}

void ReloadMap() 
{
    string mapPath = GenerateMapPath(GetMap());
    GetApp().PlaygroundScript.RequestUnloadMap();
    if (Setting_AutoReload) {
#if MP4
        CGameManiaPlanet@ app = cast<CGameManiaPlanet>(GetApp());
        auto maniaScriptAPI = app.ManiaTitleControlScriptAPI;
        while(!maniaScriptAPI.IsReady) {
            yield();
        }
        maniaScriptAPI.PlayMap(mapPath, "CampaignSolo", "");
#elif TURBO
        CTrackMania@ app = cast<CTrackMania>(GetApp());
        auto maniaScriptAPI = app.ManiaTitleFlowScriptAPI;
        while(!maniaScriptAPI.IsReady) {
            yield();
        }
        maniaScriptAPI.PlayMap(mapPath, "TMC_CampaignSolo", "");
#endif
    }
}

string GenerateMapPath(CGameCtnChallenge@ rootMap) 
{
#if MP4
    string extractPath = rootMap.MapInfo.Fid.ParentFolder.FullDirName;
    string mapName = rootMap.MapInfo.Fid.FileName;
    extractPath = Regex::Replace(extractPath + mapName, '<fake>', '');
    string loadedTitle = GetManiaPlanetAPI().LoadedTitle.TitleId;

    if (!IO::FileExists(IO::FromUserGameFolder('Maps\\Campaigns\\' + loadedTitle + '\\' + mapName))) {
        while (!Fids::Extract(rootMap.MapInfo.Fid)) yield();
        if (!IO::FolderExists(IO::FromUserGameFolder('Maps\\Campaigns\\' + loadedTitle))) IO::CreateFolder(IO::FromUserGameFolder('Maps\\Campaigns\\' + loadedTitle));
        IO::Move(IO::FromDataFolder('Extract' + extractPath), IO::FromUserGameFolder('Maps\\Campaigns\\' + loadedTitle + '\\' + mapName));
    }

    return IO::FromUserGameFolder('Maps\\Campaigns\\' + loadedTitle + '\\' + mapName);
#elif TURBO
    string path = 'Maps\\Campaigns\\';
    int mapNum = Text::ParseInt(rootMap.MapName);
    int category = int(Math::Ceil(mapNum / 40.0));
    
    if (category == 1) path += '01_White\\';
    else if (category == 2) path += '02_Green\\';
    else if (category == 3) path += '03_Blue\\';
    else if (category == 4) path += '04_Red\\';
    else path += '05_Black\\';

    int envi = mapNum % 40;
    if (Inbetween(1, 10, envi)) path += '01_Canyon\\';
    else if (Inbetween(11, 20, envi)) path += '02_Valley\\';
    else if (Inbetween(21, 30, envi)) path += '03_Lagoon\\';
    else path += '04_Stadium\\';

    return IO::FromUserGameFolder(path + formatThousandthsNumber(mapNum) + '.Map.Gbx');
#endif
}

bool Inbetween(int min, int max, int value) {return value >= min && value <= max;}

void CopyFile(const string &in targetFileLocation, const string &in copyFileLocation, bool isOutsidePlugin = false) {
    enableRead = !enableRead;
    MemoryBuffer@ buffer = isOutsidePlugin ? IO::File(targetFileLocation, IO::FileMode::Read).Read(IO::File(targetFileLocation, IO::FileMode::Read).Size()) : IO::FileSource(targetFileLocation).Read(IO::FileSource(targetFileLocation).Size()); // Read
    IO::File(copyFileLocation, IO::FileMode::Write).Write(buffer); // Write  
}

void RenderMenu() {
    if(UI::MenuItem("\\$fff" + Icons::CodeFork + "\\$z Discovered Ghosts", "", enableMenu)) {
		enableMenu = !enableMenu;
	}
    
}

class GhostId {
    int id;
    string titlepack;
    string mapName;
    string fileName;
    string Nickname;
    int raceTime;
    bool hooked;
}

GhostId CreateGhostId(int id, const string &in titlepack, const string &in mapname, const string &in filename, const string &in nickname, int racetime, bool isHooked = true) {
    GhostId ghost;
    ghost.id = id;
    ghost.titlepack = titlepack;
    ghost.mapName = mapname;
    ghost.fileName = filename;
    ghost.Nickname = nickname;
    ghost.raceTime = racetime;
    ghost.hooked = isHooked;

    return ghost;
}

void SortChangedGhosts(UI::TableColumnSortSpecs[] columnSpecs) {
    for (uint i = 0; i < columnSpecs.Length; i++) {
        if (columnSpecs[i].ColumnIndex == 0) changedGhosts.Sort(function(a,b) { return a.hooked; });
        else if (columnSpecs[i].ColumnIndex == 1) changedGhosts.Sort(function(a,b) { return a.id < b.id; });
        else if (columnSpecs[i].ColumnIndex == 2) changedGhosts.Sort(function(a,b) { return a.titlepack < b.titlepack; });
        else if (columnSpecs[i].ColumnIndex == 3) changedGhosts.Sort(function(a,b) { return a.mapName < b.mapName; });
        else if (columnSpecs[i].ColumnIndex == 4) changedGhosts.Sort(function(a,b) { return a.Nickname < b.Nickname; });
        else if (columnSpecs[i].ColumnIndex == 5) changedGhosts.Sort(function(a,b) { return a.raceTime < b.raceTime; });

        if (columnSpecs[i].SortDirection == UI::SortDirection::Ascending) changedGhosts.Reverse();
    }
}

// Returns true if the objects matches
bool CompareTableSpecs(UI::TableColumnSortSpecs[]@ object, UI::TableColumnSortSpecs[]@ otherObject) {
    if (object.Length != otherObject.Length) {return false;}

    bool ret = true;
    if (object[0].ColumnIndex != otherObject[0].ColumnIndex || object[0].SortDirection != otherObject[0].SortDirection) ret = false;
    return ret;
}

void RenderUI() {
    if (!enableMenu) {
        enableMenu = false;
		return;
	}

    UI::SetNextWindowSize(475, 350, UI::Cond::Appearing);
    if (UI::Begin("\\$08f" + Icons::CodeFork + "\\$z Discovered Ghosts", enableMenu, UI::WindowFlags::HorizontalScrollbar | UI::WindowFlags::NoCollapse)) {
        UI::BeginChild('ScrollingRegion', vec2(0, -(UI::GetFrameHeightWithSpacing() + 10)), false, UI::WindowFlags::HorizontalScrollbar);
        int counter = 1;

        UI::BeginTable("InjectedGhosts", 6, UI::TableFlags::Sortable | UI::TableFlags::SizingStretchProp);
        UI::TableSetupColumn(' ', UI::TableColumnFlags::WidthStretch | UI::TableColumnFlags::PreferSortDescending);
        UI::TableSetupColumn('ID', UI::TableColumnFlags::WidthStretch | UI::TableColumnFlags::PreferSortDescending);
        UI::TableSetupColumn('Titlepack', UI::TableColumnFlags::WidthStretch | UI::TableColumnFlags::PreferSortDescending);
        UI::TableSetupColumn('Map', UI::TableColumnFlags::WidthStretch | UI::TableColumnFlags::PreferSortDescending);
        UI::TableSetupColumn('Nickname', UI::TableColumnFlags::WidthStretch | UI::TableColumnFlags::PreferSortDescending);
        UI::TableSetupColumn('Time', UI::TableColumnFlags::WidthStretch | UI::TableColumnFlags::PreferSortDescending);
        UI::TableHeadersRow();

        if (!changedGhosts.IsEmpty()) {
            if (tableSpecs is null) tableSpecs = UI::TableGetSortSpecs().Specs;
            else if (!CompareTableSpecs(tableSpecs, UI::TableGetSortSpecs().Specs)) {
                tableSpecs = UI::TableGetSortSpecs().Specs;
                SortChangedGhosts(tableSpecs);
            }
        }


        for (uint i = 0; i < changedGhosts.Length; i++) {
            UI::TableNextRow();
            UI::TableSetColumnIndex(0);
            if (changedGhosts[i].hooked) {
                UI::PushID('Unhook' + counter);
                if (UI::ButtonColored('Unhook', 0, 1, 0.65)) {
                    IO::Delete("C:\\ProgramData\\" + GetGameType() +"\\Cache\\" + changedGhosts[i].fileName);
                    CopyFile(IO::FromDataFolder("STMGhostInject\\OriginalReplays\\" + changedGhosts[i].fileName), "C:\\ProgramData\\" + GetGameType() +"\\Cache\\" + changedGhosts[i].fileName, true);
                    IO::Delete(IO::FromDataFolder("STMGhostInject\\OriginalReplays\\" + changedGhosts[i].fileName));
                    if (GetMap() !is null && GetMap().MapName == changedGhosts[i].mapName) reloadMap = true;
                    changedGhosts[i].hooked = false;
                    UI::PopID();
                    break;
                }
                UI::PopID();
            } else {
                UI::PushID('Swap' + counter);
                if (UI::ButtonColored('  Swap  ', 0.235, 1, 0.65)) {
                    enableSelectorMenu = true;
                    overwriteIndex = i;
                    UI::PopID();
                    break;
                }
                UI::PopID();
            }
            UI::TableSetColumnIndex(1);
            UI::Text(changedGhosts[i].id + '');
            UI::TableSetColumnIndex(2);
            UI::Text(openplanetUIDisplay(changedGhosts[i].titlepack));
            UI::TableSetColumnIndex(3);
            UI::Text(openplanetUIDisplay(changedGhosts[i].mapName));
            UI::TableSetColumnIndex(4);
            UI::Text(openplanetUIDisplay(changedGhosts[i].Nickname));
            UI::TableSetColumnIndex(5);
            UI::Text(formatTime(changedGhosts[i].raceTime));
            counter++;
        }

        UI::EndTable();
        UI::EndChild();
        UI::Separator();

        if (UI::ButtonColored(Icons::Times + " Close", 0, 1, 0.65)) {
            enableMenu = !enableMenu;
        }
        UI::End();
    }
}

string[] StripPath(string[] files) {
    string[] ret = {};
    for (uint i = 0; i < files.Length; i++) {
        string[] splits = files[i].Split('/');
        if (!splits[splits.Length - 1].Contains('Ghost.Gbx')) continue;
        ret.InsertLast(splits[splits.Length - 1]);
    }
    return ret;
}

void GhostSelectorUI() {
    if (!enableSelectorMenu) {
        enableSelectorMenu = false;
        selectedCombo = '';
		return;
	}

    string[] fileList = IO::IndexFolder(Setting_OverwriteLocation, true);
    string[] displayList = StripPath(fileList);
#if TURBO
    displayList.InsertAt(0, 'RTM');
    displayList.InsertAt(0, 'STM');
#endif

    if (UI::Begin("\\$08f" + Icons::CodeFork + "\\$z Select Ghost File", enableSelectorMenu, UI::WindowFlags::AlwaysAutoResize | UI::WindowFlags::NoCollapse)) {
        if (UI::BeginCombo('File Selector', selectedCombo, UI::ComboFlags::PopupAlignLeft)) {
            for (uint i = 0; i < displayList.Length; i++) if (UI::Selectable(displayList[i], false)) selectedCombo = displayList[i];
            UI::EndCombo();
        }
        UI::Separator();

        if (UI::Button(Icons::ArrowLeft + " Select")) {
            UI::ShowNotification('Replay Successfully Overwritten!', "\\$sGhost Name: '" + openplanetUIDisplay(changedGhosts[overwriteIndex].Nickname) + "\\$fff'\nGhost Time: '" + formatTime(changedGhosts[overwriteIndex].raceTime) + "'");
            IO::Move("C:\\ProgramData\\" + GetGameType() +"\\Cache\\" + changedGhosts[overwriteIndex].fileName, IO::FromDataFolder("STMGhostInject\\OriginalReplays\\" + changedGhosts[overwriteIndex].fileName));
            OverwriteGhost(overwriteIndex, selectedCombo);
            changedGhosts[overwriteIndex].hooked = true;
            if (GetMap() !is null && GetMap().MapName == changedGhosts[overwriteIndex].mapName) reloadMap = true;
            enableSelectorMenu = false;
        }
        UI::SameLine();
        if (UI::Button(Icons::Times + " Close")) {
            enableSelectorMenu = !enableSelectorMenu;
        }
        UI::End();
    }
}
